<?php

namespace App\Controllers\Admin\Customer;

use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use CodeIgniter\Validation\Validation;
use Psr\Log\LoggerInterface;

use App\Helpers\Customer\ClientHelper;
use App\Services\Customer\ClientService;

class ClientController extends CustomerController
{
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        parent::initController($request, $response, $logger);
        $this->title = lang("{$this->getService()->getClassName()}.title");
        $this->class_path .= $this->getService()->getClassName();
        $this->uri_path .= strtolower($this->getService()->getClassName('/')) . '/';
        // $this->view_path .= strtolower($this->getService()->getClassName()) . DIRECTORY_SEPARATOR;

    }
    public function getService(): ClientService
    {
        if (!$this->_service) {
            $this->_service = new ClientService($this->request);
        }
        return $this->_service;
    }
    public function getHelper(): ClientHelper
    {
        if (!$this->_helper) {
            $this->_helper = new ClientHelper($this->request);
        }
        return $this->_helper;
    }
    //Index,FieldForm관련
    protected function setValidation(Validation $validation, string $field, string $rule): Validation
    {
        switch ($field) {
            case 'role':
                //아래 Rule Array는 필드명.* checkbox를 사용
                $validation->setRule("{$field}.*", $field, $rule);
                break;
            default:
                $validation = parent::setValidation($validation, $field,  $rule);
                break;
        }
        return $validation;
    }
    //Index,FieldForm관련.
}
